=== contrib/debian/changelog ===
zcash (1.0.12) stable; urgency=medium

  * 1.0.12 release.

 -- Zcash Company <team@z.cash>  Thu, 28 Sep 2017 01:26:44 +0100

zcash (1.0.12~rc1) stable; urgency=medium

  * 1.0.12-rc1 release.

 -- Zcash Company <team@z.cash>  Sat, 23 Sep 2017 10:51:36 +0100

zcash (1.0.11) stable; urgency=medium

  * 1.0.11 release.

 -- Zcash Company <team@z.cash>  Tue, 15 Aug 2017 10:06:25 +0100

zcash (1.0.11~rc1) stable; urgency=medium

  * 1.0.11-rc1 release.

 -- Zcash Company <team@z.cash>  Tue, 01 Aug 2017 17:12:52 +0200

zcash (1.0.10+1) stable; urgency=medium

  * 1.0.10-1 release.

 -- Zcash Company <team@z.cash>  Fri, 23 Jun 2017 19:50:41 -0700

zcash (1.0.10) stable; urgency=medium

  * 1.0.10 release.

 -- Zcash Company <team@z.cash>  Thu, 22 Jun 2017 15:13:04 +1200

zcash (1.0.9) stable; urgency=medium

  * 1.0.9 release.

 -- Zcash Company <team@z.cash>  Wed, 24 May 2017 12:51:06 -0700

zcash (1.0.8+1) jessie; urgency=high

  * 1.0.8-1 release.

 -- Zcash Company <team@z.cash>  Thu, 13 Apr 2017 20:20:37 -0700

zcash (1.0.8) jessie; urgency=medium

  * 1.0.8 release.

 -- Zcash Company <team@z.cash>  Mon, 27 Mar 2017 21:30:07 +0100

zcash (1.0.7+1) jessie; urgency=medium

  * 1.0.7-1 release.

 -- Zcash Company <team@z.cash>  Wed, 08 Mar 2017 13:51:11 -0800

zcash (1.0.7) jessie; urgency=medium

  * 1.0.7 release.

 -- Zcash Company <team@z.cash>  Fri, 03 Mar 2017 20:55:04 -0800

zcash (1.0.6) jessie; urgency=medium

  * 1.0.6 release.

 -- Zcash Company <team@z.cash>  Fri, 10 Feb 2017 10:23:00 -0800

zcash (1.0.5) jessie; urgency=medium

  * 1.0.5 release.

 -- Zcash Company <team@z.cash>  Thu, 19 Jan 2017 19:23:40 -0700

zcash (1.0.4) jessie; urgency=medium

  * 1.0.4 release.

 -- Zcash Company <team@z.cash>  Thu, 15 Dec 2016 16:46:14 +1300

zcash (1.0.3) jessie; urgency=medium

  * 1.0.3 release.

 -- Zcash Company <team@z.cash>  Wed, 17 Nov 2016 15:56:00 -0700

zcash (1.0.2) jessie; urgency=medium

  * 1.0.2 release.

 -- Zcash Company <team@z.cash>  Mon, 07 Nov 2016 19:01:35 -0600

zcash (1.0.1) jessie; urgency=medium

  * 1.0.1 release.

 -- Zcash Company <team@z.cash>  Thu, 03 Nov 2016 23:21:09 -0500

zcash (1.0.0-sprout) jessie; urgency=medium

  * 1.0.0 release.

 -- Zcash Company <team@z.cash>  Fri, 28 Oct 2016 03:00:50 -0700

zcash (1.0.0-rc4) jessie; urgency=medium

  * 1.0.0-rc4 release.

 -- Zcash Company <team@z.cash>  Thu, 27 Oct 2016 13:36:00 +0100

zcash (1.0.0-rc3) jessie; urgency=medium

  * 1.0.0-rc3 release.

 -- Zcash Company <team@z.cash>  Wed, 26 Oct 2016 23:17:03 +0100

zcash (1.0.0-rc2) jessie; urgency=medium

  * 1.0.0-rc2 release.

 -- Zcash Company <team@z.cash>  Sun, 23 Oct 2016 01:51:27 +0100

zcash (1.0.0-rc1) jessie; urgency=medium

  * Initial packaging for Debian.

 -- Zcash Company <team@z.cash>  Mon, 17 Oct 2016 11:47:02 -0700
