=== contrib/debian/control ===
Source: zcash
Section: utils
Priority: optional
Maintainer: Zcash Company <team@z.cash>
Homepage: https://z.cash
Build-Depends: autoconf, automake, bsdmainutils, build-essential,
 git, g++-multilib, libc6-dev, libtool,
 m4, ncurses-dev, pkg-config, python,
 unzip, wget, zlib1g-dev
Vcs-Git: https://github.com/zcash/zcash.git
Vcs-Browser: https://github.com/zcash/zcash

Package: zcash
Architecture: amd64
Depends: ${shlibs:Depends}
Description: HTTPS for money.
 Based on Bitcoin's code, it intends to offer a far higher standard
 of privacy and anonymity through a sophisticiated zero-knowledge
 proving scheme which preserves confidentiality of transaction metadata.
 This package provides the daemon, zcashd, and the CLI tool,
 zcash-cli, to interact with the daemon.
